import *as React from 'react';
import {
  Input,
  InputOnChangeData,
  Button,
  Form,
  ButtonProps,
} from 'semantic-ui-react';
import {multiInject} from 'inversify';

export interface StateProps {
  params?: string;
}

export interface DispatchProps {
  onResetPassword ?(pw:string, key:string):void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  pw: string;
  pwConfirm: string;
}

export class ResetPassword extends React.Component<Props, State> {
  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      pw:null,
      pwConfirm:null,
    };

    if (this.props.params === null || this.props.params === '') {
      return;
    }
  }

  public render(): JSX.Element {

    return (
      <Form>
        <Form.Input placeholder='Password' type='password' onChange={
          (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
            this.setState({ pw: data.value });
          }} />
        <Form.Input placeholder='Password Confirm' type='password' onChange={
          (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
            this.setState({ pwConfirm: data.value });
          }} />
        <Form.Group>
          <Button primary fluid style={{margin:'7'}} onClick={this.PWConfirmClick}>    Submit  </Button>
          <Button fluid style={{margin:'7'}}>    Cancel  </Button>
        </Form.Group>
      </Form>
    );
  }

  private PWConfirmClick = (event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps):void => {
    if (this.state.pw !== this.state.pwConfirm) {
      alert('Password Not Equal');
      return;
    }

    // Todo Password Reset Fetch Communication
    this.props.onResetPassword(this.state.pw, this.props.params);
  }
}

