import { connect, Dispatch } from 'react-redux';
import {
  CrawlerAuthInputs,
  CrawlerAuthInputsStateProps,
  CrawlerAuthInputsDispatchProps,
} from './components/CrawlerAuthInputs';
// import State from '../redux/state/ReadAllByTarget';

import MetaCrawler from '@overflow/meta/api/model/MetaCrawler';
import Infra from '@overflow/infra/api/model/Infra';
import AuthCrawler from '@overflow/auth/api/model/AuthCrawler';

import * as CheckAuthCrawlerActions from '@overflow/auth/redux/action/check_auth_crawler';
import * as RegistActions from '@overflow/auth/redux/action/regist';
// import * as SensorItemReadAllActions from '@overflow/meta/redux/action/sensor_item_read_all';
// import * as CrawlerReadAllByTargetActions from '../redux/action/crawler_read_all_by_target';

import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

// FIXME::....

export function mapStateToProps(state: any, props: any): CrawlerAuthInputsStateProps {
  return {
    // crawler: props.crawler,
    metaCrawlerInputItemList: props.metaCrawlerInputItemList,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): CrawlerAuthInputsDispatchProps {
  return {
    onVerifyCrawler: (infraId: number, crawler: MetaCrawler, authJson: String) => {
      dispatch(asyncRequestActions.request('AuthCrawlerService', 'checkAuthCrawler', CheckAuthCrawlerActions.REQUEST,
                                           JSON.stringify(infraId), JSON.stringify(crawler), authJson));
    },
    onRegistAuthCrawler: (authCrawler: AuthCrawler) => {
      dispatch(asyncRequestActions.request('AuthCrawlerService', 'regist', RegistActions.REQUEST,
                                           JSON.stringify(authCrawler)));
    },
    // onCrawlerReadAllByMetaCrawler: (crawler: Crawler) => {
    //   dispatch(asyncRequestActions.request('MetaCrawlerInputItemService',
    //                                        'readAllByMetaCrawler', CrawlerAuthInputsActions.REQUEST, JSON.stringify(crawler)));
    // },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(CrawlerAuthInputs);
