import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import NoAuthProbe from '@overflow/noauthprobe/api/model/NoAuthProbe';

import * as NewActionTypes from '../action/new_noauth_probe';
import NewState, { defaultState as newDefaultState } from '../state/NewNoAuthProbe';

import * as _ from 'lodash';

const reducer: ReducersMapObject = {
  [NewActionTypes.REQUEST_SUCCESS]:
  (state: NewState = newDefaultState, action: Action<NoAuthProbe>):
    NewState => {

    let nlist: Array<NoAuthProbe>;
    if (state.noauthList === undefined) {
      nlist = null;
    } else {
      nlist = _.clone(state.noauthList);
      nlist.push(action.payload);
    }

    return {
      ...state,
      noauthList: nlist,
    };
  },
  [NewActionTypes.REQUEST_FAILURE]:
  (state: NewState = newDefaultState, action: Action<Error>):
    NewState => {
    return state;
  },
};

export default reducer;
