import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Notification from '@overflow/notification/api/model/Notification';

import * as ReadActionTypes from '../action/read';
import ReadState, { defaultState as ReadDefaultState } from '../state/Read';

const reducer: ReducersMapObject = {
  [ReadActionTypes.REQUEST_SUCCESS]:
  (state: ReadState = ReadDefaultState, action: Action<Notification>):
  ReadState => {
      return {
      ...state,
      notification: <Notification>action.payload,
    };
  },
  [ReadActionTypes.REQUEST_FAILURE]:
  (state: ReadState = ReadDefaultState, action: Action<Error>):
  ReadState => {
    return state;
  },
};

export default reducer;
